package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.TimSort;
import org.openjdk.jmh.annotations.*;
import org.openjdk.jmh.infra.Blackhole;

import java.util.Arrays;
import java.util.concurrent.TimeUnit;

// TODO: The parameters are way too low. Use for debugging only!
@Fork(0)
@Warmup(iterations = 0)
@Measurement(iterations = 3)
public class BenchmarkJmh {
    @State(Scope.Benchmark)
    public static class State1 {
        Integer[] readOnly = IntegerArray.random(500_000);;
        Integer[] a;

        @Setup(Level.Invocation)
        public void setup() {
            a = Arrays.copyOf(readOnly, readOnly.length);
        }
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1DummySort(State1 s, Blackhole bh) {
        DummySort.sort(s.a, 0, s.a.length, NaturalOrder.INSTANCE, null, 0, 0);
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1TimSort(State1 s, Blackhole bh) {
        TimSort.sort(s.a, 0, s.a.length, NaturalOrder.INSTANCE, null, 0, 0);
        bh.consume(s);
    }

    @BenchmarkMode(Mode.AverageTime)
    @OutputTimeUnit(TimeUnit.MILLISECONDS)
    @Benchmark
    public void rand1MergeSort(State1 s) {
        MergeSort.legacyMergeSort(s.a, NaturalOrder.INSTANCE);
    }
}
